package de.ivu.elect.business.system.control.status;

import java.util.Collections;
import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.mandant.entity.Mandant;
import de.ivu.elect.business.system.control.SystemRequirements;
import de.ivu.elect.business.system.control.WildFlyServer;
import de.ivu.elect.business.system.entity.SystemStatusOptionGroup;
import de.ivu.elect.jee.presentation.status.StatusEntry;
import de.ivu.elect.jee.presentation.status.StatusOptionType;

/**
 *  on 26.05.2017.
 */
public class WildFlyHttpsMaxParametersSystemStatusOptionResolver extends AbstractSystemStatusOptionResolver {

  private static final StatusOptionType WILDFLY_MAX_PARAMETERS = new StatusOptionType() {
  };

  @Inject
  private transient SystemRequirements systemRequirements;

  @Inject
  private transient WildFlyServer wildFlyServer;

  @Override
  protected StatusEntry resolveSystemStatusOption(SystemStatusOption systemStatusOption) {
    long erwartet = systemRequirements.getMaxParameters();
    long vorhanden = wildFlyServer.getHttpsMaxParameters();
    if (vorhanden >= erwartet) {
      return ok("system.info.konfiguriert.maxparameters.https.ok", vorhanden);
    }
    return warn("system.info.konfiguriert.maxparameters.https.nok", vorhanden, erwartet);
  }

  @Override
  protected boolean isAccept(Mandant mandant) {
    return mandant.getArt().isSystemMandant();
  }

  @Override
  protected List<SystemStatusOption> getStatusOptionsInternal(Mandant mandant) {
    return Collections.singletonList(new SystemStatusOption(WILDFLY_MAX_PARAMETERS, mandant));
  }

  @Override
  public SystemStatusOptionGroup getSystemStatusOptionGroup() {
    return SystemStatusOptionGroup.APPSERVER_KONFIGURATION;
  }

}
